/*
 * cz2cz tools
 * Copyright (C) 2004 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include<gdbm.h>
#include<stdio.h>
#include<stdlib.h>

int main(int argc, char **argv)
{ GDBM_FILE database;
  FILE *fin;
  datum  key, nextkey, content;
  long citac=0;

  if (argc != 3) {
    printf("cz2czget verze 1.1.1\n");
    printf("--------------------\n");
    printf("Program pro prevod databaze do textoveho tvaru, vhodneho pro zpetny prevod\n"
           "do gdbm formatu pomoci programu cz2czput.\n");
    printf("Syntax: cz2czget <databazovy_soubor> <cilovy_soubor>\n");
    printf("Autor: Vlastimil Krejcir 2004\n");
    printf("Email: xkrejci4@fi.muni.cz, krejvl@email.cz\n");
    return 0;
  }
 
  if ((fin=fopen(argv[2], "w+")) == NULL) {
    fprintf(stderr, "cz2czput: Nemohu otevrit soubor \"%s\"\n", argv[2]);
    return -1;
  }

  if ((database=gdbm_open(argv[1], 512, GDBM_READER, 0644, NULL)) == NULL) {
    fprintf(stderr, "cz2czget: Nemohu otevrit databazi \"%s\".\n", argv[1]);
    fclose(fin);
    return -2;    
  }
      
  key=gdbm_firstkey(database);
  
  while(key.dptr) {
    content=gdbm_fetch(database, key);		      
    fprintf(fin, "%s ", key.dptr);
    fprintf(fin, "%s\n", content.dptr);
    citac++;
    nextkey=gdbm_nextkey(database, key);
    free((void *) content.dptr);
    free((void *) key.dptr);
    key=nextkey;
  }
 
  printf("Z databaze \"%s\" bylo vybrano %ld(*4) slov.\n", argv[1], citac/4);
  fclose(fin);
  gdbm_close(database);

  return 0;
}








