/*
 * cz2cz tools
 * Copyright (C) 2004 Vlastimil Krejcir
 *
 * This file is part of cz2cz.
 *
 * cz2cz is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include<stdio.h>
#include<gdbm.h>
#include<string.h>

#include"cz2czdef.h"

int main(int argc, char **argv)
{ GDBM_FILE database;
  FILE *fin;
  datum  key, content;
  unsigned char str_key[STR_LENGHT], str_content[4];
  long counter=0;
  

  if (argc != 3) {
    printf("cz2czput verze 1.1.1\n");
    printf("--------------------\n");
    printf("Program pro prevod slov z databaze v textovem tvaru do gdbm formatu. Lze takto\n"
           "i rozsirit jiz existujici databazi (budou pridana jen slova, ktera v rozsirova-\n"
           "ne databazi nejsou).\n"); 
    printf("Syntax: cz2czget <textovy_soubor> <databazovy_soubor>\n");
    printf("Autor: Vlastimil Krejcir 2004\n");
    printf("Email: xkrejci4@fi.muni.cz, krejvl@email.cz\n");
    return 0;
  }
  
  if ((fin=fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, "cz2czput: Nemohu otevrit soubor \"%s\"\n", argv[1]);
    return -1;
  }

  if ((database=gdbm_open(argv[2], 512, GDBM_WRCREAT, 0644, NULL)) == NULL) {
    fprintf(stderr, "cz2czput: Nemohu pripravit databazovy soubor \"%s\"\n", argv[2]); 
    fclose(fin);
    return -2;
  }

  while(fscanf(fin, "%1023s %4s", str_key, str_content) != EOF) {
    key.dptr=str_key;
    key.dsize=strlen(key.dptr)+1;
    content.dptr=str_content;
    content.dsize=4;
    if (gdbm_store(database, key, content, GDBM_INSERT) != 1) counter++;
    if (((counter%4) == 0) && (counter != 0)) { printf("#"); fflush(stdout); }
  }

  gdbm_close(database);
  fclose(fin);

  if (counter > 3) printf("\n");
  printf("cz2czput: Databaze \"%s\" rozsirena o %ld(*4) slov.\n", argv[2], counter/4);
  
  return 0;
}







